#include "cora_fit.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <float.h>

void plotlik_lam(int index)

{
 FILE *fd;
 int i;
 double test, dv;
 Vector dummy;

  if (verbose > 0)
    fprintf(stderr, "Message      : executing plotlik_lam\n");

  dv = 2. * dlam / nlik;

  vec_init(&dummy);
  vec_alloc(&dummy,2.*nlines);

  for (i=0;i<nlines;++i)
      {dummy.vec[i] = llambda.vec[i];dummy.vec[i+nlines] = lsigma.vec[i];}
  test=llambda.vec[index]-dlam;
  fd = fopen ("like_lam.dat", "w");
  for (i=0;i<nlik;++i)
   {
    dummy.vec[index] = test + dv*i;
    fprintf(fd,"%f  %f\n",dummy.vec[index],func_lik(&(dummy.vec[0]),&dummy.len));
   }

  fclose(fd);
  fprintf(stderr, "Message      : file like_lam.dat created.\n");

 return;
}

void plotlik_sig(int index)

{
 FILE *fd;
 int i, ntimes=1;
 double test, dv;
 Vector dummy;

  if (verbose > 0)
    fprintf(stderr, "Message      : executing plotlik_sig\n");

  dv = 2. * ntimes * dsig / nlik;

/* initialize callik (ampstart could be zero when starting with sigma=0) */
callik();

  vec_init(&dummy);
  vec_alloc(&dummy,2.*nlines);

  for (i=0;i<nlines;++i)
      {dummy.vec[i] = llambda.vec[i];dummy.vec[i+nlines] = lsigma.vec[i];}
  test=lsigma.vec[index] - ntimes*dsig;
  fd = fopen ("like_sig.dat", "w");
  for (i=0;i<nlik;++i)
   {
    dummy.vec[nlines+index] = test + ntimes*dv*i;
    fprintf(fd,"%f  %f\n",dummy.vec[nlines+index],func_lik(&(dummy.vec[0]),&dummy.len));
   }

  fclose(fd);
  fprintf(stderr, "Message      : file like_sig.dat created.\n");

 return;
}

/* ----------------------------------- */

void plotlik_lam_all(double (*func)(), double * p_vec, int * N, int clflag)

{

 static FILE *fd1;
 static int init;
 static Vector P;

/* int i;
 double test; */

  if (init == 0)
    {
     vec_init(&P);
     vec_alloc(&P,*N);
     fd1 = fopen ("lik1.dat", "w");

     init=1;
    }

  P.vec = p_vec;
  P.len = *N;

/*  for (i=0;i<nlines;++i) {dummy.vec[i] = llambda.vec[i];dummy.vec[i+nlines] = lsigma.vec[i];} */

   fprintf(fd1,"%f  %f\n",llambda.vec[0],func(&(P.vec[0]), &P.len));

  if (clflag == 1) fclose(fd1);

return;
}

/* ----------------------------------- */

void note_lik(Vector * P, double like, int clflag)

{
 /*  takes notes of likelihood values calculated during minimazytion */
 /*    call from the individual function in functions.c */ 
 static FILE *fd1;
 static int init;

  if (init == 0)
    {
     fd1 = fopen ("lik1.dat", "w");

     init=1;
    }

   fprintf(fd1,"%f  %f\n",P->vec[0],like);

  if (clflag == 1) fclose(fd1);

return;
}

